Index: trunk/hal/generic/hal_special.h
===================================================================
--- trunk/hal/generic/hal_special.h	(revision 457)
+++ trunk/hal/generic/hal_special.h	(revision 480)
@@ -41,10 +41,10 @@
  * This function returns the calling core status register value.
  ****************************************************************************************/
-inline reg_t hal_get_sr();
+inline reg_t hal_get_sr( void );
 
 /*****************************************************************************************
  * This function returns the global core identifier from the calling core register.
  ****************************************************************************************/
-inline gid_t hal_get_gid();
+inline gid_t hal_get_gid( void );
 
 /*****************************************************************************************
@@ -52,5 +52,5 @@
  * This cycle counter is reset when the core is initialised (at each boot).
  ****************************************************************************************/
-inline reg_t hal_time_stamp();
+inline reg_t hal_time_stamp( void );
 
 /*****************************************************************************************
@@ -59,10 +59,10 @@
  * This cycle counter is reset when the core is initialised (at each boot).
  ****************************************************************************************/
-cycle_t hal_get_cycles();
+cycle_t hal_get_cycles( void );
 
 /*****************************************************************************************
  * This function returns the current thread pointer from the calling core register.
  ****************************************************************************************/
-inline struct thread_s * hal_get_current_thread();
+inline struct thread_s * hal_get_current_thread( void );
 
 /*****************************************************************************************
@@ -74,25 +74,25 @@
  * This function writes into the proper core register to enable the floating point unit.
  ****************************************************************************************/
-void hal_fpu_enable();
+void hal_fpu_enable( void );
 
 /*****************************************************************************************
  * This function writes into the proper core register to disable the floating point unit.
  ****************************************************************************************/
-void hal_fpu_disable();
+void hal_fpu_disable( void );
 
 /*****************************************************************************************
  * This function returns the current value of stack pointer from core register.
  ****************************************************************************************/
-uint32_t hal_get_stack();
+uint32_t hal_get_stack( void );
 
 /*****************************************************************************************
  * This function registers a new value in the core stack pointer and returns previous one.
  ****************************************************************************************/
-extern inline uint32_t hal_set_stack( void * new_val );
+inline uint32_t hal_set_stack( void * new_val );
 
 /*****************************************************************************************
  * This function returns the faulty address in case of address exception.
  ****************************************************************************************/
-uint32_t hal_get_bad_vaddr();
+uint32_t hal_get_bad_vaddr( void );
 
 /*****************************************************************************************
@@ -112,15 +112,15 @@
  * This blocking function flushes the write buffer to synchronize all pending writes.
  ****************************************************************************************/
-void hal_fence();
+void hal_fence( void );
 
 /*****************************************************************************************
  * This forbids code reordering accross this barrier by the compiler.
  ****************************************************************************************/
-void hal_rdbar();
+void hal_rdbar( void );
 
 /*****************************************************************************************
  * This function forces the calling core in idle-low-power mode.
  ****************************************************************************************/
-void hal_core_sleep();
+void hal_core_sleep( void ) __attribute__((__noreturn__));
 
 /*****************************************************************************************