Index: trunk/hal/tsar_mips32/core/hal_exception.c
===================================================================
--- trunk/hal/tsar_mips32/core/hal_exception.c	(revision 473)
+++ trunk/hal/tsar_mips32/core/hal_exception.c	(revision 481)
@@ -396,5 +396,5 @@
 
 ///////////////////////
-void hal_do_exception()
+void hal_do_exception( void )
 {
     uint32_t   * uzone;
Index: trunk/hal/tsar_mips32/core/hal_interrupt.c
===================================================================
--- trunk/hal/tsar_mips32/core/hal_interrupt.c	(revision 473)
+++ trunk/hal/tsar_mips32/core/hal_interrupt.c	(revision 481)
@@ -30,5 +30,5 @@
 
 ///////////////////////
-void hal_do_interrupt()
+void hal_do_interrupt( void )
 {
     // ALMOS-MKH does not define a generic interrupt handler.
Index: trunk/hal/tsar_mips32/core/hal_kentry.h
===================================================================
--- trunk/hal/tsar_mips32/core/hal_kentry.h	(revision 473)
+++ trunk/hal/tsar_mips32/core/hal_kentry.h	(revision 481)
@@ -97,5 +97,5 @@
  * to address contained in EPC calling hal_kentry_eret()
  ************************************************************************************/
-void hal_kentry_enter();
+void hal_kentry_enter( void );
 
 /*************************************************************************************
@@ -104,5 +104,5 @@
  * contained in the c0_epc register. 
  * ************************************************************************************/
-void hal_kentry_eret();
+void hal_kentry_eret( void );
 
 #endif	/* _HAL_KENTRY_H_ */
Index: trunk/hal/tsar_mips32/core/hal_special.c
===================================================================
--- trunk/hal/tsar_mips32/core/hal_special.c	(revision 473)
+++ trunk/hal/tsar_mips32/core/hal_special.c	(revision 481)
@@ -33,5 +33,5 @@
 
 //////////////////////////
-inline gid_t hal_get_gid()
+inline gid_t hal_get_gid( void )
 {
 	uint32_t proc_id;
@@ -43,5 +43,5 @@
 
 /////////////////////////////
-inline reg_t hal_time_stamp()
+inline reg_t hal_time_stamp( void )
 {
     reg_t count;
@@ -53,5 +53,5 @@
 
 /////////////////////////
-inline reg_t hal_get_sr()
+inline reg_t hal_get_sr( void )
 {
     reg_t sr;
@@ -63,5 +63,5 @@
 
 /////////////////////////
-uint64_t hal_get_cycles()
+uint64_t hal_get_cycles( void )
 {
 	uint64_t cycles;                // absolute time to be returned
@@ -95,5 +95,5 @@
 
 /////////////////////////////////////////////////
-inline struct thread_s * hal_get_current_thread()
+inline struct thread_s * hal_get_current_thread( void )
 {
 	void * thread_ptr;
@@ -111,5 +111,5 @@
 
 /////////////////////
-void hal_fpu_enable()
+void hal_fpu_enable( void )
 {
     // set CU1 bit (FPU enable) in c0_sr
@@ -128,5 +128,5 @@
 
 //////////////////////
-void hal_fpu_disable()
+void hal_fpu_disable( void )
 {
     // reset CU1 bit (FPU enable) in c0_sr
@@ -146,5 +146,5 @@
 
 ////////////////////////
-uint32_t hal_get_stack()
+uint32_t hal_get_stack( void )
 {
 	register uint32_t sp;
@@ -169,5 +169,5 @@
 
 ////////////////////////////
-uint32_t hal_get_bad_vaddr()
+uint32_t hal_get_bad_vaddr( void )
 {
 	register uint32_t bad_va;
@@ -202,5 +202,5 @@
 
 ////////////////
-void hal_fence()
+void hal_fence( void )
 {
 	asm volatile ("sync");
@@ -208,5 +208,5 @@
 
 ////////////////
-void hal_rdbar()
+void hal_rdbar( void )
 {
 	asm volatile( "" ::: "memory" );
@@ -214,5 +214,5 @@
 
 /////////////////////
-void hal_core_sleep()
+void hal_core_sleep( void )
 {
 	while( 1 ) asm volatile ("nop");
Index: trunk/hal/tsar_mips32/core/hal_syscall.c
===================================================================
--- trunk/hal/tsar_mips32/core/hal_syscall.c	(revision 473)
+++ trunk/hal/tsar_mips32/core/hal_syscall.c	(revision 481)
@@ -30,5 +30,5 @@
 
 /////////////////////
-void hal_do_syscall()
+void hal_do_syscall( void )
 {
     thread_t    * this;
Index: trunk/hal/tsar_mips32/core/hal_user.c
===================================================================
--- trunk/hal/tsar_mips32/core/hal_user.c	(revision 473)
+++ trunk/hal/tsar_mips32/core/hal_user.c	(revision 481)
@@ -84,5 +84,5 @@
 
 /////////////////////
-void hal_user_fence()
+void hal_user_fence( void )
 {
 	asm volatile ( "sync" );